
# ~/.zshrc

# Folding used. Get folding.el for your emacs here:
# http://www.csd.uu.se/~andersl/emacs.shtml

# To use folding under Vim put this to your ~/.vimrc
# set foldmethod=marker

# Under sh-script mode of emacs do this:
# C-c : zsh

#echo "~/.zshrc"

# {{{ Loading help

# ~/.zprofile reads ~/.profile

#if [ -n "$HOME_PROFILE" ]
#then
#    if [ "$HOME_PROFILE" -gt 0 ]
#    then
#        #  echo PAH ~/.profile
#        :
#    fi
#else
#    #  echo SUCK ~/.profile
#    . "${HOME}/.profile"
#fi

#unset HOME_PROFILE

if test -f "/etc/debian_version"
then
    if test -f "$HOME/.profile.debian.sh"
    then
        if test -n "$PROFILE_DEBIAN" -a "$PROFILE_DEBIAN" -gt 0
        then
            #echo PAH ~/.profile.debian.sh
            :
        else
            #echo SUCK ~/.profile.debian.sh
            . "${HOME}/.profile.debian.sh"
        fi
    fi
fi

if test -f "/etc/redhat-release"
then
    if test -f "$HOME/.profile.redhat.sh"
    then
        if test -n "$PROFILE_REDHAT" -a "$PROFILE_REDHAT" -gt 0
        then
            #echo PAH ~/.profile.redhat.sh
            :
        else
            #echo SUCK ~/.profile.redhat.sh
            . "${HOME}/.profile.redhat.sh"
        fi
    fi
fi


# ~/.zshenv reads ~/.kshrc
# but let's be sure:

# .kshrc may have something too ksh-specific

#if [ -n "$HOME_KSHRC" ]
#then
#    if [ "$HOME_KSHRC" -gt 0 ]
#    then
#        #echo PAH ~/.kshrc
#        :
#    fi
#else
#    #echo SUCK ~/.kshrc
#    . "$HOME/.kshrc"
#    HOME_KSHRC="1"
#    export HOME_KSHRC
#fi

# ~/.kshrc reads ~/.shinit.sh
# but let's be sure

if [ -n "$HOME_SHINIT" ]
then
    if [ "$HOME_SHINIT" -gt 0 ]
    then
        #echo PAH ~/.shinit.sh
        :
    fi
else
    #echo SUCK ~/.shinit.sh
    . "${HOME}/.shinit.sh"
    HOME_SHINIT="1"
    export HOME_SHINIT

fi


# It seems, that those emulate-commands somehow fsck up some things,
# I have configured in ~/.zshenv. As long, as my $HOME/.kshrc does not
# have anything too ksh-specific, I keep those emulate-commands commented.

# }}}
# {{{ ZSH-specific things for root

# ADD THIS TO PROMPT:
# %S${ROOTTEXT}%s${ROOTPROMPTADD}
# AND THIS TO TITLE:
# ${ROOTTEXT}${ROOTTITLEADD}

export ROOTTEXT="%(!.-=*[ROOT ZSH]*=-.)"
export ROOTPROMPTADD="%(!. .)"
export ROOTTITLEADD="%(!. | .)"

if (( EUID == 0 ))
then
    PS2="%B$PS2%b"
    PS3="%B$PS3%b"
    PS4="%B$PS4%b"
    SPROMPT="%B$SPROMPT%b"
    # Rewt do not use ispell, E-Mail, Usenet News or IRC.
    unset MAIL MAILCHECK MAILPATH 2> /dev/null
    unset IRCNAME IRCSERVER IRCNICK 2> /dev/null
    unset NNTPSERVER 2> /dev/null
    unset SSH_AGENT_PID SSH_AUTH_SOCK 2> /dev/null
    unset hostnames mailpath 2> /dev/null
    unset DICTIONARY
fi

#rootbold()
#{
#PS2="%B$PS2%b"
#PS3="%B$PS3%b"
#PS4="%B$PS4%b"
#SPROMPT="%B$SPROMPT%b"
#}


#rootboldtest()
#{
#    if (( EUID == 0 ))
#    then
#        rootbold
#    fi
#}

#rootboldtest



# }}}
# {{{ Environment variables

# See man page strftime(3) for more details.
MY_DATE="%D{%a %d %b %Y}"
MY_TIME="%D{%H:%M:%S}"

# Uncomment these, if you want to use those prompts that need these:
#MY_NUMBER_DATE="%D{%Y-%m-%d}"
#MY_DATE_FORMAT="%a %d %b %Y"
#MY_NUMBER_DATE_FORMAT="%Y-%m-%d"
#MY_TIME_FORMAT="%H:%M:%S"


# How to get the whole hostname reliably
# This does not work under Solaris, I think.
#  echo -n "`hostname -s`." ; hostname -d

# Uncomment these, if you want to use those prompts that need these:
#case `uname -s` in
#    *SunOS*|*Darwin*)
#    SHORTHOST=$(echo -n "`hostname`")
#    ;;
#
#    *)
#    WHOLEHOST=$(echo -n "`hostname -s`." ; echo -n `hostname -d`)
#    SHORTHOST=$(echo -n "`hostname -s`")
#    DOMAINHOST=$(echo -n "`hostname -d`")
#esac


HISTFILE="${HOME}/.zhistory"
SAVEHIST=10000
HISTSIZE=10000
DIRSTACKSIZE=10

# Colored filename-completion!!11!!!

#echo $LS_COLORS

ZLS_COLORS="$LS_COLORS"
export ZLS_COLORS
zmodload zsh/complist 2> /dev/null

# directory for run-help function to find docs
#unalias run-help
autoload run-help
#export HELPDIR=/usr/local/share/zsh/help

# Paranoia

umask 077

# LOGOUT AFTER TIMEOUT
#TMOUT=1800

# Finlanndisierung or Finlandization

# I am am Finn. I live in Finland. I speak Finnish. Perkele!

# http://www.odci.gov/cia/publications/factbook/geos/fi.html
# http://www.funet.fi/resources/clickable-Suomi.html
# http://www.helsinki.fi/~eisaksso/tarja.html
# http://www.godhatesfags.com/finland.html
# http://www.godhatesfags.com/finland.gif

#set translation latin_1
#set translation latin_9
#set translation latin_9
set eight on

# }}}
# {{{ Prompt colors

#/usr/share/zsh/4.0.2/functions/Misc/colors

# Attribute codes:
#  00 none
#  01 bold
#  02 faint                  22 normal
#  03 standout               23 no-standout
#  04 underline              24 no-underline
#  05 blink                  25 no-blink
#  07 reverse                27 no-reverse
#  08 conceal

# Text color codes:
#  30 black                  40 bg-black
#  31 red                    41 bg-red
#  32 green                  42 bg-green
#  33 yellow                 43 bg-yellow
#  34 blue                   44 bg-blue
#  35 magenta                45 bg-magenta
#  36 cyan                   46 bg-cyan
#  37 white                  47 bg-white
#  39 default                49 bg-default

#PS1="%{"$'\e[01;31m'"%}$PS1%{"$'\e[00m'"%}"
#             ^^ ^^                 ^^
#             |  |                  |
#          bold  red                reset

#export FOO="%{"$'\e[31m'"%}"
#PS1="${FOO}$PS1%{"$'\e[0m'"%}"

# DEFINE ALL COLORS IN THIS PLACE
# for example color for "%h" is in variable "COLOR_p_h"
# except
# color for "%#" is in variable "COLOR_p_hash"
# color for "%/" is in variable "COLOR_p_slash"
# color for "%*" is in variable "COLOR_p_star"
# color for "@" is in variable "COLOR_at"

#COLOR="%{"$'\e[31m'"%}"

if (( EUID == 0 ))
then
    COLOR_ROOT_BOLD="%{"$'\e[01m'"%}"
    COLOR_RESET="%{"$'\e[39;49;01m'"%}"
else
    COLOR_ROOT_BOLD=""
    COLOR_RESET="%{"$'\e[39;49;00m'"%}"
fi

COLOR_REAL_RESET="%{"$'\e[39;49;00m'"%}"

colorize()
{
    COLOR_p_h="%{"$'\e[32;44m'"%}"
    COLOR_p_l="%{"$'\e[32;44m'"%}"
    COLOR_p_y="%{"$'\e[32;44m'"%}"

    COLOR_p_n="%{"$'\e[35;43m'"%}"
    COLOR_at="%{"$'\e[35;43m'"%}"
    COLOR_p_m="%{"$'\e[35;43m'"%}"

    COLOR_WHOLEHOST="%{"$'\e[35;43m'"%}"
    COLOR_SHORTHOST="%{"$'\e[35;43m'"%}"
    COLOR_DOMAINHOST="%{"$'\e[35;43m'"%}"

    COLOR_p_D="%{"$'\e[31;46m'"%}"
    COLOR_MY_DATE="%{"$'\e[31;46m'"%}"
    COLOR_p_star="%{"$'\e[31;46m'"%}"
    COLOR_MY_TIME="%{"$'\e[31;46m'"%}"

    COLOR_ROOT="%{"$'\e[01;31;43m'"%}"

    if (( EUID == 0 ))
    then
        COLOR_p_hash="${COLOR_ROOT}"
        COLOR_p_slash="${COLOR_ROOT}"
    else
        COLOR_p_hash="%{"$'\e[01;03;33;44m'"%}"
        COLOR_p_slash="%{"$'\e[31;43m'"%}"
    fi

    $LATEST_PROMPT
}

uncolorize()
{
    COLOR_p_h="${COLOR_RESET}"
    COLOR_p_l="${COLOR_RESET}"
    COLOR_p_y="${COLOR_RESET}"

    COLOR_p_n="${COLOR_RESET}"
    COLOR_at="${COLOR_RESET}"
    COLOR_p_m="${COLOR_RESET}"

    COLOR_WHOLEHOST="${COLOR_RESET}"
    COLOR_SHORTHOST="${COLOR_RESET}"
    COLOR_DOMAINHOST="${COLOR_RESET}"

    COLOR_p_D="${COLOR_RESET}"
    COLOR_MY_DATE="${COLOR_RESET}"
    COLOR_p_star="${COLOR_RESET}"
    COLOR_MY_TIME="${COLOR_RESET}"

    COLOR_ROOT="%{"$'\e[39;49;01m'"%}"

    if (( EUID == 0 ))
    then
        COLOR_p_hash="%s${COLOR_ROOT}"
        COLOR_p_slash="%s${COLOR_ROOT}"
    else
        COLOR_p_hash="${COLOR_RESET}"
        COLOR_p_slash="${COLOR_RESET}"
    fi

    $LATEST_PROMPT
}


# So, you don't like those colors anymore and your eyes are burning
# and bleeding?  Just comment away "colorize" and uncomment
# "uncolorize". You can give those commands via command line, too.

colorize
#uncolorize

# }}}
# {{{ Prompts

# It takes too much time to start up my shell, if I have so many
# prompt-changing functions.  If you like some of these, just uncomment them.
# Currently all prompts I use are publicprompt and cutthreelineprompt.

#cutprompt()
#{
#export PS1="${COLOR_ROOT_BOLD}${COLOR_ROOT}%S${ROOTTEXT}%s${COLOR_RESET}$ROOTPROMPTADD${COLOR_p_n}%n${COLOR_RESET}${COLOR_at}@${COLOR_RESET}${COLOR_p_m}%m${COLOR_RESET}:${COLOR_p_slash}%/${COLOR_RESET} ${COLOR_p_hash}%#${COLOR_REAL_RESET} "
#export RPROMPT="${COLOR_ROOT_BOLD}${COLOR_p_h}%h${COLOR_RESET} | ${COLOR_p_y}%y${WINDOW:+.${WINDOW}}${COLOR_REAL_RESET}"
#LATEST_PROMPT="cutprompt"
#}

#cutthreelinefullhostprompt()
#{
#export PS1="${COLOR_ROOT_BOLD}${COLOR_ROOT}%S${ROOTTEXT}%s${COLOR_RESET}${ROOTPROMPTADD}${COLOR_p_n}%n${COLOR_RESET}${COLOR_at}@${COLOR_RESET}${COLOR_WHOLEHOST}${WHOLEHOST}${COLOR_RESET}%E
#${COLOR_p_slash}%/${COLOR_RESET}
#${COLOR_p_hash}%#${COLOR_RESET}${COLOR_REAL_RESET} "
#export RPROMPT="${COLOR_ROOT_BOLD}${COLOR_p_h}%h${COLOR_RESET} | ${COLOR_p_y}%y${WINDOW:+.${WINDOW}}${COLOR_REAL_RESET}"
#LATEST_PROMPT="cutthreelinefullhostprompt"
#}

#cutthreelineprompt()
#{
#export PS1="${COLOR_ROOT_BOLD}${COLOR_ROOT}%S${ROOTTEXT}%s${COLOR_RESET}$ROOTPROMPTADD${COLOR_p_n}%n${COLOR_RESET}${COLOR_at}@${COLOR_RESET}${COLOR_p_m}%m${COLOR_RESET}%E
#${COLOR_p_slash}%/${COLOR_RESET}
#${COLOR_p_hash}%#${COLOR_REAL_RESET} "
#export RPROMPT="${COLOR_ROOT_BOLD}${COLOR_p_h}%h${COLOR_RESET} | ${COLOR_p_y}%y${WINDOW:+.${WINDOW}}${COLOR_REAL_RESET}"
#LATEST_PROMPT="cutthreelineprompt"
#}

cutthreelinetimeprompt()
{
export PS1="${COLOR_ROOT_BOLD}${COLOR_ROOT}%S${ROOTTEXT}%s${COLOR_RESET}$ROOTPROMPTADD${COLOR_p_n}%n${COLOR_RESET}${COLOR_at}@${COLOR_RESET}${COLOR_p_m}%m${COLOR_RESET} | ${COLOR_MY_DATE}${MY_DATE}${COLOR_RESET} ${COLOR_MY_TIME}${MY_TIME}${COLOR_RESET}%E
${COLOR_p_slash}%/${COLOR_RESET}
${COLOR_p_hash}%#${COLOR_REAL_RESET} "
export RPROMPT="${COLOR_ROOT_BOLD}${COLOR_p_h}%h${COLOR_RESET} | ${COLOR_p_y}%y${WINDOW:+.${WINDOW}}${COLOR_REAL_RESET}"
LATEST_PROMPT="cutthreelinetimeprompt"
}

#cutthreelinetimefullhostprompt()
#{
#export PS1="${COLOR_ROOT_BOLD}${COLOR_ROOT}%S${ROOTTEXT}%s${COLOR_RESET}$ROOTPROMPTADD${COLOR_p_n}%n${COLOR_RESET}${COLOR_at}@${COLOR_RESET}${COLOR_WHOLEHOST}${WHOLEHOST}${COLOR_RESET} | ${COLOR_MY_DATE}${MY_DATE}${COLOR_RESET} ${COLOR_MY_TIME}${MY_TIME}${COLOR_RESET}%E
#${COLOR_p_slash}%/${COLOR_RESET}
#${COLOR_p_hash}%#${COLOR_REAL_RESET} "
#export RPROMPT="${COLOR_ROOT_BOLD}${COLOR_p_h}%h${COLOR_RESET} | ${COLOR_p_y}%y${WINDOW:+.${WINDOW}}${COLOR_REAL_RESET}"
#LATEST_PROMPT="cutthreelinetimefullhostprompt"
#}

#cuttwolineprompt()
#{
#export PS1="${COLOR_ROOT_BOLD}${COLOR_ROOT}%S${ROOTTEXT}%s${COLOR_RESET}$ROOTPROMPTADD${COLOR_p_n}%n${COLOR_RESET}${COLOR_at}@${COLOR_RESET}${COLOR_p_m}%m${COLOR_RESET} : ${COLOR_p_slash}%/${COLOR_RESET}
#${COLOR_p_hash}%#${COLOR_REAL_RESET} "
#export RPROMPT="${COLOR_ROOT_BOLD}${COLOR_p_h}%h${COLOR_RESET} | ${COLOR_p_y}%y${WINDOW:+.${WINDOW}}${COLOR_REAL_RESET}"
#LATEST_PROMPT="cuttwolineprompt"
#}

#fsckinglongprompt()
#{
#export PS1="${COLOR_ROOT_BOLD}${COLOR_ROOT}%S${ROOTTEXT}%s${COLOR_RESET}$ROOTPROMPTADD${COLOR_p_h}%h${COLOR_RESET}|${COLOR_p_y}%y${WINDOW:+.${WINDOW}}${COLOR_RESET}|${COLOR_p_n}%n${COLOR_RESET}${COLOR_at}@${COLOR_RESET}${COLOR_WHOLEHOST}${WHOLEHOST}${COLOR_RESET}:${COLOR_p_slash}%/${COLOR_RESET} ${COLOR_p_hash}%#${COLOR_REAL_RESET} "
#unset RPROMPT
#LATEST_PROMPT="fsckinglongprompt"
#}

#fsckinglongtimeprompt()
#{
#export PS1="${COLOR_ROOT_BOLD}${COLOR_ROOT}%S${ROOTTEXT}%s${COLOR_RESET}$ROOTPROMPTADD${COLOR_p_h}%h${COLOR_RESET}|${COLOR_p_y}%y${WINDOW:+.${WINDOW}}${COLOR_RESET}|${COLOR_MY_DATE}${MY_DATE}${COLOR_RESET} ${COLOR_MY_TIME}${MY_TIME}${COLOR_RESET}|${COLOR_p_n}%n${COLOR_RESET}${COLOR_at}@${COLOR_RESET}${COLOR_WHOLEHOST}${WHOLEHOST}${COLOR_RESET}:${COLOR_p_slash}%/${COLOR_RESET} ${COLOR_p_hash}%#${COLOR_REAL_RESET} "
#unset RPROMPT
#LATEST_PROMPT="fsckinglongtimeprompt"
#}

#hostprompt()
#{
#export PS1="${COLOR_ROOT_BOLD}${COLOR_ROOT}%S${ROOTTEXT}%s${COLOR_RESET}$ROOTPROMPTADD${COLOR_p_m}%m${COLOR_RESET} ${COLOR_p_hash}%#${COLOR_REAL_RESET} "
#unset RPROMPT
#LATEST_PROMPT="hostprompt"
#}

#longprompt()
#{
#export PS1="${COLOR_ROOT_BOLD}${COLOR_ROOT}%S${ROOTTEXT}%s${COLOR_RESET}$ROOTPROMPTADD${COLOR_p_h}%h${COLOR_RESET}|${COLOR_p_y}%y${WINDOW:+.${WINDOW}}${COLOR_RESET}|${COLOR_p_n}%n${COLOR_RESET}${COLOR_at}@${COLOR_RESET}${COLOR_p_m}%m${COLOR_RESET}:${COLOR_p_slash}%/${COLOR_RESET} ${COLOR_p_hash}%#${COLOR_REAL_RESET} "
#unset RPROMPT
#LATEST_PROMPT="longprompt"
#}

publicprompt()
{
    # I use this with Midnight Commander. Two line prompts and RPROMPT
    # are no good for MC.

    # This is also good, when creating bug reports or when writing to
    # Usenet News, because RPROMPT may annoy or misguide
    # reader(s). Therefore I call this "publicprompt".

export PS1="${COLOR_ROOT_BOLD}${COLOR_ROOT}%S${ROOTTEXT}%s${COLOR_RESET}$ROOTPROMPTADD${COLOR_p_n}%n${COLOR_RESET}${COLOR_at}@${COLOR_RESET}${COLOR_p_m}%m${COLOR_RESET}:${COLOR_p_slash}%/${COLOR_RESET} ${COLOR_p_hash}%#${COLOR_REAL_RESET} "
unset RPROMPT
LATEST_PROMPT="publicprompt"
}

#pwdcutprompt()
#{
#export PS1="${COLOR_ROOT_BOLD}${COLOR_ROOT}%S${ROOTTEXT}%s${COLOR_RESET}$ROOTPROMPTADD${COLOR_p_slash}%/${COLOR_RESET} ${COLOR_p_hash}%#${COLOR_REAL_RESET} "
#export RPROMPT="${COLOR_ROOT_BOLD}${COLOR_p_n}%n${COLOR_RESET}${COLOR_at}@${COLOR_RESET}${COLOR_p_m}%m${COLOR_RESET}:${COLOR_p_h}%h${COLOR_RESET}|${COLOR_p_y}%y${WINDOW:+.${WINDOW}}${COLOR_REAL_RESET}"
#LATEST_PROMPT="pwdcutprompt"
#}

#pwdprompt()
#{
#export PS1="${COLOR_ROOT_BOLD}${COLOR_ROOT}%S${ROOTTEXT}%s${COLOR_RESET}$ROOTPROMPTADD${COLOR_p_slash}%/${COLOR_RESET} ${COLOR_p_hash}%#${COLOR_REAL_RESET} "
#unset RPROMPT
#LATEST_PROMPT="pwdprompt"
#}

#threelinefullhostprompt()
#{
#export PS1="${COLOR_ROOT_BOLD}${COLOR_ROOT}%S${ROOTTEXT}%s${COLOR_RESET}$ROOTPROMPTADD${COLOR_p_n}%n${COLOR_RESET}${COLOR_at}@${COLOR_RESET}${COLOR_WHOLEHOST}${WHOLEHOST}${COLOR_RESET} | ${COLOR_p_h}%h${COLOR_RESET} | ${COLOR_p_y}%y${WINDOW:+.${WINDOW}}${COLOR_RESET}%E
#${COLOR_p_slash}%/${COLOR_RESET}
#${COLOR_p_hash}%#${COLOR_RESET}${COLOR_REAL_RESET} "
#unset RPROMPT
#LATEST_PROMPT="threelinefullhostprompt"
#}

#threelineprompt()
#{
#export PS1="${COLOR_ROOT_BOLD}${COLOR_ROOT}%S${ROOTTEXT}%s${COLOR_RESET}$ROOTPROMPTADD${COLOR_p_n}%n${COLOR_RESET}${COLOR_at}@${COLOR_RESET}${COLOR_p_m}%m${COLOR_RESET} | ${COLOR_p_h}%h${COLOR_RESET} | ${COLOR_p_y}%y${WINDOW:+.${WINDOW}}${COLOR_RESET}%E
#${COLOR_p_slash}%/${COLOR_RESET}
#${COLOR_p_hash}%#${COLOR_REAL_RESET} "
#unset RPROMPT
#LATEST_PROMPT="threelineprompt"
#}

#threelinetimeprompt()
#{
#export PS1="${COLOR_ROOT_BOLD}${COLOR_ROOT}%S${ROOTTEXT}%s${COLOR_RESET}$ROOTPROMPTADD${COLOR_p_n}%n${COLOR_RESET}${COLOR_at}@${COLOR_RESET}${COLOR_p_m}%m${COLOR_RESET} | ${COLOR_MY_DATE}${MY_DATE}${COLOR_RESET} ${COLOR_MY_TIME}${MY_TIME}${COLOR_RESET} | ${COLOR_p_h}%h${COLOR_RESET} | ${COLOR_p_y}%y${WINDOW:+.${WINDOW}}${COLOR_RESET}%E
#${COLOR_p_slash}%/${COLOR_RESET}
#${COLOR_p_hash}%#${COLOR_REAL_RESET} "
#unset RPROMPT
#LATEST_PROMPT="threelinetimeprompt"
#}

#threelinetimefullhostprompt()
#{
#export PS1="${COLOR_ROOT_BOLD}${COLOR_ROOT}%S${ROOTTEXT}%s${COLOR_RESET}$ROOTPROMPTADD${COLOR_p_n}%n${COLOR_RESET}${COLOR_at}@${COLOR_RESET}${COLOR_WHOLEHOST}${WHOLEHOST}${COLOR_RESET} | ${COLOR_MY_DATE}${MY_DATE}${COLOR_RESET} ${COLOR_MY_TIME}${MY_TIME}${COLOR_RESET} | ${COLOR_p_h}%h${COLOR_RESET} | ${COLOR_p_y}%y${WINDOW:+.${WINDOW}}${COLOR_RESET}%E
#${COLOR_p_slash}%/${COLOR_RESET}
#${COLOR_p_hash}%#${COLOR_REAL_RESET} "
#unset RPROMPT
#LATEST_PROMPT="threelinetimefullhostprompt"
#}

#twolinefullhostprompt()
#{
#export PS1="${COLOR_ROOT_BOLD}${COLOR_ROOT}%S${ROOTTEXT}%s${COLOR_RESET}$ROOTPROMPTADD${COLOR_p_h}%h${COLOR_RESET} | ${COLOR_p_y}%y${WINDOW:+.${WINDOW}}${COLOR_RESET} | ${COLOR_p_n}%n${COLOR_RESET}${COLOR_at}@${COLOR_RESET}${COLOR_WHOLEHOST}${WHOLEHOST}${COLOR_RESET} : ${COLOR_p_slash}%/${COLOR_RESET}%E
#${COLOR_p_hash}%#${COLOR_REAL_RESET} "
#unset RPROMPT
#LATEST_PROMPT="twolinefullhostprompt"
#}

#twolineprompt()
#{
#export PS1="${COLOR_ROOT_BOLD}${COLOR_ROOT}%S${ROOTTEXT}%s${COLOR_RESET}$ROOTPROMPTADD${COLOR_p_h}%h${COLOR_RESET} | ${COLOR_p_y}%y${WINDOW:+.${WINDOW}}${COLOR_RESET} | ${COLOR_p_n}%n${COLOR_RESET}${COLOR_at}@${COLOR_RESET}${COLOR_p_m}%m${COLOR_RESET} : ${COLOR_p_slash}%/${COLOR_RESET}%E
#${COLOR_p_hash}%#${COLOR_REAL_RESET} "
#unset RPROMPT
#LATEST_PROMPT="twolineprompt"
#}

#prompts()
#{
#cat <<EOF
#Available prompts are:
#
# cutprompt, cutthreelinefullhostprompt, cutthreelineprompt,
# cutthreelinetimeprompt, cutthreelinetimefullhostprompt,
# cuttwolineprompt, fsckinglongprompt, fsckinglongtimeprompt,
# hostprompt, longprompt, publicprompt, pwdcutprompt, pwdprompt,
# threelinefullhostprompt, threelineprompt, threelinetimeprompt,
# threelinetimefullhostprompt, twolinefullhostprompt and twolineprompt
#
#EOF
#}

defaultprompt()
{
    # CHOOSE ONE PROMPT

    #longprompt
    #twolineprompt
    #cuttwolineprompt
    #threelinetimeprompt
    cutthreelinetimeprompt
}

defaultprompt

case `uname -s` in
    *SunOS*)

export PS1="%B%n@%m | ${MY_DATE} ${MY_TIME}%E | %h
%/
%S%#%s%b "
unset RPROMPT
;;

*)
:
esac

# }}}
# {{{ Cool titlebars

# (I want the same text to both title and icon)

# Don't forget to check out my ~/.screenrc ! There is some stuff about
# writing to titlebar when using screen.

# DEFINE WHAT YOU WANT TO TITLE OF EVERY TERMINAL IN THIS ONE PLACE

writetitle()
{
    # ${WINDOW} is set by a program called screen. Woohou!
    export TITLETEXT="${ROOTTEXT}${ROOTTITLEADD}%n@%m:%d | ${COLUMNS}x${LINES} | %y${WINDOW:+.${WINDOW}}"
}

writeexectitle()
{
    #  export EXECTEXT0="${ROOTTEXT}${ROOTTITLEADD}"
    #  export EXECTEXT1="%n@%m:%d : "
    export EXECTEXT1="${ROOTTEXT}${ROOTTITLEADD}%n@%m:%d : "
    export EXECTEXT2="$*"
}

# TERMINAL TYPES

case "$TERM" in
    *xterm*|rxvt*|putty*|gnome-terminal|*onsole|zvt|(dt|k|E|z)term)
    precmd()
    {
        writetitle
        print -Pn "\e]0;${TITLETEXT}\a"
        unset TITLETEXT
    }

    preexec()
    {
        writeexectitle $1
        print -Pn '\e]0;'"${EXECTEXT1}"
        print -rn "${EXECTEXT2}"
        print -Pn '\a'
        unset EXECTEXT1 EXECTEXT2
    }
    ;;

    vt100)
    # This is weird but true:

    # Apple's MacOS X includes a Terminal.app derived from the old NeXT
    # Terminal.app. It is a partial VT100 emulation with some extensions.
    #
    # There are no function keys, at least not in version 41.
    #
    # It supports mouse pointer position reporting using xterm-like
    # sequences (not used in these entries.) When using emacs, the cursor
    # can be positioned using option-click.
    #
    # It provides partial ANSI color support (background colors interact
    # badly with bold, though.) The monochrome (-m) entries are useful if
    # you've disabled color support.
    #
    # The configurable titlebar is set using xterm-compatible sequences;
    # it is used as a status bar in these entries.
    #
    # The MacRoman character encoding is used for some of the alternate
    # characters in the "MacRoman" entries; the "ASCII" (-ascii) entries
    # rely instead on Terminal.app's own buggy VT100 graphics emulation,
    # which seems to think the character encoding is the old NeXT charset
    # instead of MacRoman.
    #
    # Terminal.app reports "vt100" as the terminal type, but exports
    # several environment variables which may aid detection in a shell
    # profile:
    #
    # TERM=vt100
    # TERM_PROGRAM=Apple_Terminal
    # TERM_PROGRAM_VERSION=41


    if test "$TERM_PROGRAM" = "Apple_Terminal"
    then
        precmd()
        {
            writetitle
            print -Pn "\e]0;${TITLETEXT}\a"
            unset TITLETEXT
        }

        preexec()
        {
            writeexectitle $1
            print -Pn '\e]0;'"${EXECTEXT1}"
            print -rn "${EXECTEXT2}"
            print -Pn '\a'
            unset EXECTEXT1 EXECTEXT2
        }
    fi
    ;;


    screen|screen-w|screen-16color*|screen-256color*)
    precmd()
    {
        writetitle
        print -Pn "\e_${TITLETEXT}\e\\"
        unset TITLETEXT
    }

    preexec()
    {
        writeexectitle $1
        print -Pn "\e_""${EXECTEXT1}"
        print -rn "${EXECTEXT2}"
        print -Pn "\e\\"
        unset EXECTEXT1 EXECTEXT2
    }
    ;;

    # I just wanted to speed up my zsh startup so I disabled this.
    # UNCOMMENT THIS ONLY IF YOU ARE REALLY SO PERVERTED THAT YOU WANT TO
    # TORTURE YOURSELF WITH THOSE DISTORTED PICTURES OF TERMINALS BEING
    # OF TERMINAL TYPE sun-cmd :

    #sun-cmd)
    #  echo "ARE YOU CRAZY OR DRUNK???++?? EVEN OLD GRANNIES THAT ARE MET ON THE STREET
    #KNOW THAT TERMINAL EMULATORS OF TERMINAL TYPE $TERM ARE AWFUL, DISGUSTING AND
    #B0RKEN!!111!!! THOSE TWO DISTORTED PICTURES OF TERMINAL SUXXX0R SNOW OUT OF
    #MT. FUJI, ROTTEN FROGS AND GOLF BALLS THROUGH A GARDEN HOSE AND RAW EGGS
    #THROUGH A VERY THIN STRAW!!11!!! GET A LIFE, HINT AND SOME TERMINAL EMULATOR,
    #YOU SUCKER!!!!!111!!11!!! IF YOUR BOFH CAN'T PROVIDE SOME TERMINAL EMULATOR,
    # AND FORCES YOU TO USE TERMINAL EMULATORS OF TERMINAL TYPE $TERM ,
    # THEN TELL HIM/HER TO FSCK HIMSELF GENTLY WITH A CHAINSAW!!!11!!!"

    #    precmd()
    #    {
    #        writetitle
    #        print -Pn "\e]l${TITLETEXT}\e\\"
    #        print -Pn "\e]L${TITLETEXT}\e\\"
    #    }
    #
    #    preexec()
    #    {
    #      writeexectitle $1
    #      print -Pn "\e]l${EXECTEXT1}"
    #      print -rn "${EXECTEXT2}"
    #      print -Pn "\e\\"
    #
    #      print -Pn "\e]L${EXECTEXT1}"
    #      print -rn "${EXECTEXT2}"
    #      print -Pn "\e\\"
    #   }
    #;;

    # I HAVE ONLY ONCE SAT IN FRONT OF SOME SGI-BOX AND THIS SEEMED TO WORK
    iris-ansi)
    precmd()
    {
        writetitle
        print -Pn "\eP1.y${TITLETEXT}\e\\" ## window title
        print -Pn "\eP3.y${TITLETEXT}\e\\" ## icon title
        unset TITLETEXT
    }

    preexec()
    {
        writeexectitle $1

        print -Pn "\eP1.y${EXECTEXT1}" ## window title
        print -rn "${EXECTEXT2}"       ## window title
        print -Pn "\e\\"               ## window title

        print -Pn "\eP3.y${EXECTEXT1}" ## icon title
        print -rn "${EXECTEXT2}"       ## icon title
        print -Pn "\e\\"               ## icon title
        unset EXECTEXT1 EXECTEXT2
    }
    ;;

    # I HAVEN'T BEEN ABLE TO TEST THIS TERMINAL TYPE
    hpterm)
    precmd ()
    {
        writetitle
        str="\e]0;${TITLETEXT}\a"
        print -Pn "\e&f0k${#str}D${str}"
        print -Pn "\e&f-1k${#str}D${str}"
        unset TITLETEXT
    }

    preexec()
    {
        writeexectitle $1
        str="\e]0;${EXECTEXT1}\a"
        print -Pn "\e&f0k${#str}D${str}"
        print -Pn "\e&f-1k${#str}D${str}"
        str="\e]0;${EXECTEXT2}\a"
        print -rn "\e&f0k${#str}D${str}"
        print -rn "\e&f-1k${#str}D${str}"
        unset EXECTEXT1 EXECTEXT2
    }
    ;;

    *)
    true

esac

# }}}
# {{{ Aliases

# there are some crappy aliases in rc's of "inferior" Bourne-like
# shells

unalias which 2> /dev/null
unalias cp 2> /dev/null
unalias md 2> /dev/null
unalias mkdir 2> /dev/null
unalias mv 2> /dev/null

# WHAT THE FSCK :-)
# In my system /usr/games/wtf is some program
alias wtfsck='whence -savc'

alias lsd='ls -d *(-/DN)'       # list directories & symbolic links
alias lsa='ls -ad .*'           # list files beginning with "."

if gcp --help 2>&1 | grep -i "gnu.org" > /dev/null 2>&1
then
    alias cp='nocorrect gcp -i -p'
else
    alias cp='nocorrect cp -i -p'
fi

if gmkdir --help 2>&1 | grep -i "gnu.org" > /dev/null 2>&1
then
    alias mkdir='nocorrect gmkdir -p'
    alias md='nocorrect gmkdir -p'
else
    alias mkdir='nocorrect mkdir -p'
    alias md='nocorrect mkdir -p'
fi

if gmv --help 2>&1 | grep -i "gnu.org" > /dev/null 2>&1
then
    alias mv='nocorrect gmv -i'
else
    alias mv='nocorrect mv -i'
fi

# I HAVE UPGRADED TO XFree86 4.* AND THEN X.org
# Therefore I have -depth and no more -bpp
# FIXME: Create shell script
alias myx='startx -- -dpi 100 -depth 24 & disown && exit'

#alias myx8='startx -- -dpi 100 -depth 8 & disown && exit'
#alias myx16='startx -- -dpi 100 -depth 16 & disown && exit'
#alias myx24='startx -- -dpi 100 -depth 24 & disown && exit'

# }}}
# {{{ Watch other users

# ENABLE ME
# Big Brother^H^H^H^H^H^H^H^H^H^H^Hjuhtolv is watching you...
#set -A watch $USER root %console frodo kallio jahakala antkaij
#set -A watch $USER root %console erno perttit
set -A watch $USER root perttit heikotil miasti
export LOGCHECK=60
export WATCHFMT='%n %a %l from %m at %T'
export WATCHFMT='%n has %a %l %(M:from %M :)at %T.'

#export WATCHFMT="[%B${MY_NUMBER_DATE} ${MY_TIME}%b] %B%n%b has %a %B%l%b from %B%M%b"

# Loosely based on this (by Adam Spiers):
#WATCHFMT="[%B%t%b] %B%n%b has %a %B%l%b from %B%M%b"

# I can put some color to WATCHFMT, too... Oh my gawd! I belong to
# insane asylum...

# Attribute codes:
#  00 none
#  01 bold
#  02 faint                  22 normal
#  03 standout               23 no-standout
#  04 underline              24 no-underline
#  05 blink                  25 no-blink
#  07 reverse                27 no-reverse
#  08 conceal

# Text color codes:
#  30 black                  40 bg-black
#  31 red                    41 bg-red
#  32 green                  42 bg-green
#  33 yellow                 43 bg-yellow
#  34 blue                   44 bg-blue
#  35 magenta                45 bg-magenta
#  36 cyan                   46 bg-cyan
#  37 white                  47 bg-white
#  39 default                49 bg-default

#PS1="%{"$'\e[01;31m'"%}$PS1%{"$'\e[00m'"%}"
#             ^^ ^^                 ^^
#             |  |                  |
#          bold  red                reset

#export FOO="%{"$'\e[31m'"%}"
#PS1="${FOO}$PS1%{"$'\e[0m'"%}"

# DEFINE ALL WATCH_COLORS IN THIS PLACE
# for example color for "%h" is in variable "WATCH_COLOR_p_h"
# except

# UNCOMMENT THESE IF YOU REALLY NEED TO WATCH PEOPLE

watchcolorize()
{
    WATCH_COLOR_RESET=$'\e[39;49;00m'

    WATCH_COLOR_bracket=$'\e[37;40m'

    WATCH_COLOR_p_a_ON=$'\e[32;49m'
    WATCH_COLOR_p_a_OFF=$'\e[31;49m'

    WATCH_COLOR_p_l=$'\e[32;44m'

    WATCH_COLOR_p_n=$'\e[35;43m'
    WATCH_COLOR_p_m=$'\e[35;43m'
    WATCH_COLOR_p_M=$'\e[35;43m'

    WATCH_COLOR_p_D=$'\e[32;49m'
    WATCH_COLOR_MY_DATE=$'\e[32;49m'
    WATCH_COLOR_MY_NUMBER_DATE=$'\e[32;49m'
    WATCH_COLOR_MY_TIME=$'\e[32;49m'
    WATCH_COLOR_MY_NUMBER_TIME=$'\e[32;49m'
    export WATCHFMT="${WATCH_COLOR_bracket}[${WATCH_COLOR_RESET}${WATCH_COLOR_MY_NUMBER_DATE}%B${MY_NUMBER_DATE} ${MY_TIME}%b${WATCH_COLOR_RESET}${WATCH_COLOR_bracket}]${WATCH_COLOR_RESET} ${WATCH_COLOR_p_n}%B%n%b${WATCH_COLOR_RESET} has %(a:${WATCH_COLOR_p_a_ON}:${WATCH_COLOR_p_a_OFF})%a${WATCH_COLOR_RESET}%(a: :) ${WATCH_COLOR_p_l}%B%l%b${WATCH_COLOR_RESET} from ${WATCH_COLOR_p_M}%B%M%b${WATCH_COLOR_RESET}"
    unset WATCH_COLOR_RESET
    unset WATCH_COLOR_bracket
    unset WATCH_COLOR_p_a_ON
    unset WATCH_COLOR_p_a_OFF
    unset WATCH_COLOR_p_l
    unset WATCH_COLOR_p_n
    unset WATCH_COLOR_p_m
    unset WATCH_COLOR_p_M
    unset WATCH_COLOR_p_D
    unset WATCH_COLOR_MY_DATE
    unset WATCH_COLOR_MY_NUMBER_DATE
    unset WATCH_COLOR_MY_TIME
    unset WATCH_COLOR_MY_NUMBER_TIME
}

watchuncolorize()
{
    export WATCHFMT="[%B${MY_NUMBER_DATE} ${MY_TIME}%b] %B%n%b has %a%(a: :) %B%l%b from %B%M%b"
}


# So, you don't like those colors anymore and your eyes are burning
# and bleeding?  Just comment away "watchcolorize" and uncomment
# "watchuncolorize". You can give those commands via command line,
# too.

watchcolorize
#watchuncolorize

# Give this command to check all watched lusers:
if test "$LINES" -gt 26
then
    log
fi

# }}}
# {{{ Keybindings

stty eof '^D'

stty erase '^?'


# Emacs keybindings.
bindkey -e

# vi-like keybindings:
#bindkey -v


bindkey "$(echotc kl)" backward-char
bindkey "$(echotc kr)" forward-char
bindkey "$(echotc ku)" up-line-or-history
bindkey "$(echotc kd)" down-line-or-history

bindkey "\e[3~" delete-char        # Delete
#bindkey -a "\e[25~" delete-char   # Delete (according to Greg J. Badros)

#bindkey "$(echotc )" delete-char
#bindkey "$(echotc )" backward-delete-char

# Complete /usr/loc/b to /usr/local/bin with Ctrl-x <TAB>

bindkey "^X^I" expand-or-complete-prefix

# }}}
# {{{ Functions

# {{{ Inferior shells

myash ()
{
    OLDPS1="$PS1"
    OLDSHELL="$SHELL"
    OLDENV="$ENV"

    if test -f "/bin/dash"
    then
        SHELL="/bin/dash"
        PS1='[dash] $ '
        export PS1

    elif test -f "/usr/bin/ash.medium"
    then
        SHELL="/usr/bin/ash.medium"
        PS1='[ash.medium] $ '
        export PS1

    elif test -f "/bin/ash"
    then
        SHELL=/bin/ash
        PS1='[ash] $ '
        export PS1
    else
        echo 'It seems you do not have (Debian) Almquist Shell installed at all' >&2
        return 1
    fi

    NO_SWITCH="yes"
    export NO_SWITCH
    OLD_ZSH_VERSION="$ZSH_VERSION"
    unset ZSH_VERSION

    OLD_ETC_PROFILE="$ETC_PROFILE"
    OLD_HOME_SHINIT="$HOME_SHINIT"
    OLD_HOME_PROFILE="$HOME_PROFILE"
    OLD_PROFILE_DEBIAN="$PROFILE_DEBIAN"
    OLD_PROFILE_REDHAT="$PROFILE_REDHAT"

    unset ETC_PROFILE
    unset HOME_SHINIT
    unset HOME_PROFILE

    unset PROFILE_DEBIAN
    unset PROFILE_REDHAT

    . "$HOME/.profile"
    ENV=$HOME/.shinit.sh
    export ENV

    SHELL="$SHELL" $SHELL "$@"

    PS1="$OLDPS1"
    SHELL="$OLDSHELL"
    ENV="$OLDENV"
    export ENV PS1
    unset NO_SWITCH
    ZSH_VERSION="$OLD_ZSH_VERSION"

    ETC_PROFILE="$OLD_ETC_PROFILE"
    HOME_SHINIT="$OLD_HOME_SHINIT"
    HOME_PROFILE="$OLD_HOME_PROFILE"

    PROFILE_DEBIAN="$OLD_PROFILE_DEBIAN"
    PROFILE_REDHAT="$OLD_PROFILE_REDHAT"

    unset OLDPS1 OLDSHELL OLDENV
    unset OLD_ETC_PROFILE
    unset OLD_HOME_SHINIT OLD_HOME_PROFILE
    unset OLD_PROFILE_DEBIAN OLD_PROFILE_REDHAT
}

ash ()
{
    myash "$@"
}

dash ()
{
    myash "$@"
}


posh ()
{
    OLDPS1="$PS1"
    OLDSHELL="$SHELL"
    OLDENV="$ENV"

    if test -f "/bin/posh"
    then
        SHELL="/bin/posh"
    elif test -f "/usr/bin/posh"
    then
        SHELL=/usr/bin/posh
    else
        echo 'It seems you do not have Policy-compliant Ordinary SHell installed at all' >&2
        return 1
    fi

    NO_SWITCH="yes"
    export NO_SWITCH

    OLD_ZSH_VERSION="$ZSH_VERSION"
    unset ZSH_VERSION

    OLD_ETC_PROFILE="$ETC_PROFILE"
    OLD_HOME_SHINIT="$HOME_SHINIT"
    OLD_HOME_PROFILE="$HOME_PROFILE"
    OLD_PROFILE_DEBIAN="$PROFILE_DEBIAN"
    OLD_PROFILE_REDHAT="$PROFILE_REDHAT"

    unset ETC_PROFILE
    unset HOME_SHINIT
    unset HOME_PROFILE

    unset PROFILE_DEBIAN
    unset PROFILE_REDHAT

    . "$HOME/.profile"
    ENV=$HOME/.shinit.sh
    export ENV

    PS1='[posh] $ '
    export PS1

    SHELL="$SHELL" $SHELL "$@"

    PS1="$OLDPS1"
    SHELL="$OLDSHELL"
    ENV="$OLDENV"
    export ENV PS1
    unset NO_SWITCH
    ZSH_VERSION="$OLD_ZSH_VERSION"

    ETC_PROFILE="$OLD_ETC_PROFILE"
    HOME_SHINIT="$OLD_HOME_SHINIT"
    HOME_PROFILE="$OLD_HOME_PROFILE"

    PROFILE_DEBIAN="$OLD_PROFILE_DEBIAN"
    PROFILE_REDHAT="$OLD_PROFILE_REDHAT"

    unset OLDPS1 OLDSHELL OLDENV
    unset OLD_ETC_PROFILE
    unset OLD_HOME_SHINIT OLD_HOME_PROFILE
    unset OLD_PROFILE_DEBIAN OLD_PROFILE_REDHAT
}


bash ()
{
    OLDPS1="$PS1"
    OLDSHELL="$SHELL"
    OLDENV="$ENV"

    SHELL="`whence -p bash`"

    NO_SWITCH="yes"
    export NO_SWITCH
    OLD_ZSH_VERSION="$ZSH_VERSION"
    unset ZSH_VERSION


    OLD_ETC_PROFILE="$ETC_PROFILE"
    OLD_ETC_BASHRC="$ETC_BASHRC"
    OLD_ETC_BASH_BASHRC="$ETC_BASH_BASHRC"
    OLD_HOME_SHINIT="$HOME_SHINIT"
    OLD_HOME_PROFILE="$HOME_PROFILE"
    OLD_HOME_BASHRC="$HOME_BASHRC"
    OLD_HOME_BASH_COMMON="$HOME_BASH_COMMON"
    OLD_HOME_BASH_PROFILE="$HOME_BASH_PROFILE"
    OLD_PROFILE_DEBIAN="$PROFILE_DEBIAN"
    OLD_PROFILE_REDHAT="$PROFILE_REDHAT"

    unset ETC_PROFILE
    unset ETC_BASHRC
    unset ETC_BASH_BASHRC
    unset HOME_SHINIT
    unset HOME_PROFILE
    unset HOME_BASH_COMMON
    unset HOME_BASHRC
    unset HOME_BASH_PROFILE
    unset PROFILE_DEBIAN
    unset PROFILE_REDHAT

    ENV=$HOME/.bashrc
    export ENV
    BASH_ENV=$HOME/.bashrc
    export BASH_ENV

    SHELL="$SHELL" $SHELL "$@"

    PS1="$OLDPS1"
    SHELL="$OLDSHELL"
    ENV="$OLDENV"
    export ENV PS1
    unset BASH_ENV NO_SWITCH
    ZSH_VERSION="$OLD_ZSH_VERSION"

    ETC_PROFILE="$OLD_ETC_PROFILE"
    ETC_BASHRC="$OLD_ETC_BASHRC"
    ETC_BASH_BASHRC="$OLD_ETC_BASH_BASHRC"
    HOME_SHINIT="$OLD_HOME_SHINIT"
    HOME_PROFILE="$OLD_HOME_PROFILE"
    HOME_BASH_COMMON="$OLD_HOME_BASH_COMMON"
    HOME_BASHRC="$OLD_HOME_BASHRC"
    HOME_BASH_PROFILE="$OLD_HOME_BASH_PROFILE"
    PROFILE_DEBIAN="$OLD_PROFILE_DEBIAN"
    PROFILE_REDHAT="$OLD_PROFILE_REDHAT"

    unset OLDPS1 OLDSHELL OLDENV
    unset OLD_ETC_PROFILE
    unset OLD_HOME_BASH_COMMON
    unset OLD_ETC_BASH_BASHRC
    unset OLD_ETC_BASHRC
    unset OLD_HOME_SHINIT OLD_HOME_PROFILE
    unset OLD_HOME_BASHRC OLD_HOME_BASH_PROFILE
    unset OLD_PROFILE_DEBIAN OLD_PROFILE_REDHAT

}


myksh ()
{
    OLDPS1="$PS1"
    OLDSHELL="$SHELL"
    OLDENV="$ENV"

    if test -f "/bin/ksh93"
    then 
        SHELL="/bin/ksh93"
    elif test -f "/usr/bin/ksh93"
    then 
        SHELL="/usr/bin/ksh93"
    elif test -f "/usr/dt/bin/ksh"
    then 
        SHELL="/usr/dt/bin/ksh"
    elif test -f "/bin/ksh"
    then
        SHELL="/bin/ksh"
    elif test -f "/usr/bin/ksh"
    then
        SHELL="/usr/bin/ksh"
    elif test -f "/bin/pdksh"
    then
        SHELL="/bin/pdksh"
    else
        echo 'It seems you do not have (pd)ksh installed at all' >&2
        return 1
    fi

    NO_SWITCH="yes"
    export NO_SWITCH
    OLD_ZSH_VERSION="$ZSH_VERSION"
    unset ZSH_VERSION

    OLD_ETC_PROFILE="$ETC_PROFILE"
    OLD_HOME_SHINIT="$HOME_SHINIT"
    OLD_HOME_PROFILE="$HOME_PROFILE"
    OLD_PROFILE_DEBIAN="$PROFILE_DEBIAN"
    OLD_PROFILE_REDHAT="$PROFILE_REDHAT"

    unset ETC_PROFILE
    unset HOME_SHINIT
    unset HOME_PROFILE
    unset PROFILE_DEBIAN
    unset PROFILE_REDHAT

    ENV="$HOME/.kshrc"
    export ENV NO_SWITCH

    PS1='[ksh] $ '
    export PS1

    SHELL="$SHELL" $SHELL "$@"

    ETC_PROFILE="$OLD_ETC_PROFILE"
    HOME_SHINIT="$OLD_HOME_SHINIT"
    HOME_PROFILE="$OLD_HOME_PROFILE"

    PROFILE_DEBIAN="$OLD_PROFILE_DEBIAN"
    PROFILE_REDHAT="$OLD_PROFILE_REDHAT"

    PS1="$OLDPS1"
    SHELL="$OLDSHELL"
    ENV="$OLDENV"
    export PS1 ENV
    unset OLDENV
    unset NO_SWITCH
    ZSH_VERSION="$OLD_ZSH_VERSION"

    unset OLDPS1 OLDSHELL OLDENV
    unset OLD_ETC_PROFILE
    unset OLD_HOME_SHINIT OLD_HOME_PROFILE
    unset OLD_PROFILE_DEBIAN OLD_PROFILE_REDHAT
}

ksh93 ()
{
    myksh "$@"
}

ksh ()
{
    myksh "$@"
}

pdksh ()
{
    myksh "$@"
}

sh ()
{
    if dash "$@"
    then
        :
    elif ash "$@"
    then
        :
    elif posh "$@"
    then
        :
    else
        OLDPS1="$PS1"
        OLDSHELL="$SHELL"
        OLDENV="$ENV"

        if test -f "/usr/xpg4/bin/sh"
        then
            SHELL="/usr/xpg4/bin/sh"
            PS1='[/usr/xpg4/bin/sh] $ '
            export PS1
        elif test -f "/usr/bin/jsh"
        then
            SHELL="/usr/bin/jsh"
            PS1='[/usr/bin/jsh] $ '
            export PS1
        elif test -f "/bin/sh"
        then
            SHELL="/bin/sh"
            PS1='[/bin/sh] $ '
            export PS1
        elif test -f "/usr/bin/sh"
        then
            SHELL="/usr/bin/sh"
            PS1='[/usr/bin/sh] $ '
            export PS1
        else
            echo 'It seems you do not have Bourne Shell installed at all' >&2
            echo 'In the other words: This machine must be b0rken!' >&2
            return 1
        fi


        NO_SWITCH="yes"
        export NO_SWITCH
        OLD_ZSH_VERSION="$ZSH_VERSION"
        unset ZSH_VERSION

        OLD_ETC_PROFILE="$ETC_PROFILE"
        OLD_HOME_SHINIT="$HOME_SHINIT"
        OLD_HOME_PROFILE="$HOME_PROFILE"
        OLD_PROFILE_DEBIAN="$PROFILE_DEBIAN"
        OLD_PROFILE_REDHAT="$PROFILE_REDHAT"

        unset ETC_PROFILE
        unset HOME_SHINIT
        unset HOME_PROFILE

        unset PROFILE_DEBIAN
        unset PROFILE_REDHAT

        . "$HOME/.profile"
        ENV="$HOME/.shinit.sh"
        export ENV
        SHELL="$SHELL" $SHELL "$@"

        PS1="$OLDPS1"
        SHELL="$OLDSHELL"
        ENV="$OLDENV"
        export ENV PS1
        unset NO_SWITCH
        ZSH_VERSION="$OLD_ZSH_VERSION"

        ETC_PROFILE="$OLD_ETC_PROFILE"
        HOME_SHINIT="$OLD_HOME_SHINIT"
        HOME_PROFILE="$OLD_HOME_PROFILE"

        PROFILE_DEBIAN="$OLD_PROFILE_DEBIAN"
        PROFILE_REDHAT="$OLD_PROFILE_REDHAT"

        unset OLDPS1 OLDSHELL OLDENV
        unset OLD_ETC_PROFILE
        unset OLD_HOME_SHINIT OLD_HOME_PROFILE
        unset OLD_PROFILE_DEBIAN OLD_PROFILE_REDHAT

    fi
}

# }}}

####################################################
# These are originally from Ville "viznut" Heikkil
# FIXME: Create shell scripts of these
#

google()
{
    lynx http://www.google.com/search\?q=${@}
}

fm()
{
    lynx http://www.freshmeat.net/search/\?q=${@}
}

#########################################################################
# tar-functions
# FIXME: Create shell scripts of these

# AFAIK star is faster and better than GNU tar
# http://www.fokus.gmd.de/research/cc/glone/employees/joerg.schilling/private/star.html

if star --version 2>&1 | grep -i "Schilling" > /dev/null 2>&1
then
    TAR_BIN="star -time -fifostats"
elif gtar --help 2>&1 | grep -i "gnu.org" > /dev/null 2>&1
then
    TAR_BIN="gtar"
else
    TAR_BIN="tar"
fi

############################################################
# This is originally from Risto J. Laitinen.
# $TAR_BIN and other compatibility with star is my addition
#

untar()
{
    local f="$1" filter='' cmd=x
    shift

    case "$f" in 
        (*.tar.bz2|*.tbz2)
        filter=bzip2
        ;;
        (*.tar.gz|*.tar.[zZ]|*.tgz)
        filter=gzip
        ;;
    esac

    if [[ -n "$filter" ]]
    then
        $filter -dc "$f" | $TAR_BIN -x -v -v -v -v -f - "$@"
    else
        $TAR_BIN -x -v -v -v -v -f "$f" "$@"
    fi
}

#
# lstar is created by Juhapekka Tolvanen, but based on aforementioned
# untar. Does not extract, just lists files.
#

# <RANT>

# Some fscking idiots haven't read Software Release Practice HOWTO
# (by Eric S. "ESR" Raymond). Therefore I had to create this function

# http://www.tldp.org/HOWTO/Software-Release-Practice-HOWTO/index.html
# http://www.tldp.org/HOWTO/Software-Release-Practice-HOWTO/distpractice.html#TARBALLS

#7.1. Make sure tarballs always unpack into a single new directory

# The single most annoying mistake newbie developers make is to build
# tarballs that unpack the files and directories in the distribution into
# the current directory, potentially stepping on files already located
# there. Never do this!

# Instead, make sure your archive files all have a common directory part
# named after the project, so they will unpack into a single top-level
# directory directly beneath the current one.

# </RANT>

lstar()
{
    local f="$1" filter='' cmd=x
    shift

    case "$f" in 
        (*.tar.bz2|*.tbz2)
        filter=bzip2
        ;;
        (*.tar.gz|*.tar.[zZ]|*.tgz)
        filter=gzip
        ;;
    esac

    if [[ -n "$filter" ]]
    then
        $filter -dc "$f" | $TAR_BIN -t -v -v -v -v -f - "$@"
    else
        $TAR_BIN -t -v -v -v -v -f "$f" "$@"
    fi
}

# This is from Risto J. Laitinen

readme()
{
    local files
    files=(./*([Rr][Ee][Aa][Dd]*[Mm][Ee]|[Ll][Uu][Ee]*[Mm]([Ii][Nn]|)[Uu][Tt])*(ND))
    if (($#files))
    then
        $PAGER $files
    else
        print No README files.
    fi
}

loadallzshrc ()
{
    . "/etc/profile"

    . "/etc/zsh/zshenv"
    . "${HOME}/.zshenv"

    . "/etc/zsh/zprofile"
    . "${HOME}/.zprofile"

    . "/etc/zsh/zshrc"
    . "${HOME}/.zshrc"

    . "/etc/zsh/zlogin"
    . "${HOME}/.zlogin"
}

# }}}
# {{{ Modules

autoload -U zmv 2> /dev/null
autoload zmv

# }}}
# {{{ compctl

#####################
# MY OWN COMPLETIONS

# DPKG-COMPLETIONS
# I think this is nowadays handled well already

#if [ -f /usr/share/doc/zsh/examples/compctl.dpkg ] ;
#  then
#   .  /usr/share/doc/zsh/examples/compctl.dpkg 
#elif [ -f /usr/doc/zsh/examples/compctl.dpkg ] ;
#  then
#  .  /usr/doc/zsh/examples/compctl.dpkg 
#fi

# FETA

if type feta > /dev/null 2>&1
then
    compctl -D -f + -UQ -K multicomp
    fetacmds=(`feta commands`)
    pkgnames=(`apt-cache pkgnames`)
    compctl -x 'p[1]' -k fetacmds - 'p[2,-1]' -k pkgnames -- feta
fi

compctl -c man nohup fakeroot whence wtfsck

hostnames=(localhost juhtolv tukki.cc.jyu.fi kanto.cc.jyu.fi wildeast.cc.jyu.fi irc.jyu.fi )

usernames=(juhtolv root)

compctl -k hostnames telnet rlogin rsh ssh ping ftp ncftp lftp
# This is from Risto J. Laitinen
# Rmdir only real directories
compctl -g '*(D/)' rmdir 

# This is from Risto J. Laitinen
# Cd/pushd only directories or symbolic links to directories
compctl -g '*(D-/)' cd pushd

# This is from Risto J. Laitinen
# TeX
compctl -g '*.tex* *.ltx *.latex' + -g '*(-/)' tex latex amstex lamstex texi2dvi makeinfo
compctl -g '*.dvi' + -g '*(-/)' xdvi dvips
compctl -g '*.<->gf' gftodvi gftopk


#######
# THESE TWO ARE NOT NEEDED IN ZSH 3.1.6 or better, I think.

# From Timo Korvola http://www.iki.fi/tkorvola :

#compctl -x 'n[1,=] n[-1,:], n[1,=]' -f -- + -v export

# Same thing from Hannu Koivisto azure@iki.fi 


#compctl -v -x 'n[-1,:][1,=]' -f -- typeset local declare export


####
# from Sven Guckes w/ my modification:
# rcp completes hostnames with a `:' suffix or filenames or usernames with
# `@' suffix. It completes hostnames after @.
compctl -k hostnames -S ':~/' + -f + -x 'N[-1,@]' -k hostnames -S ':' - 's[]' -u -S '@' -- rcp scp scp1 scp2

# my conversion
#compctl -g '*.(pdf)' acroread xpdf 

compctl -g '*.(ps|eps|ps.gz|eps.gz)' gv ghostview

#
#
####

#
#####

# }}}
# {{{ compinit

# I don't know what happens to those compctl-commands if I load
# compinit.

#if test -d /usr/share/zsh/functions
#then
#  fpath=(/usr/share/zsh/functions)
#elif test -d /usr/share/zsh/${ZSH_VERSION}/functions
#then
#  fpath=(/usr/share/zsh/${ZSH_VERSION}/functions)
#fi

autoload compinit 2> /dev/null
autoload -U compinit 2> /dev/null
compinit 2> /dev/null

# The following lines were added by compinstall

# I had zsh 3.1.9-dev-8, when I did these and they seem to work fine with zsh
# 4.0.2. If you have some other version, these might not work and especially if
# you have version 3.0.* or older.

zstyle ':completion:*' insert-unambiguous true
zstyle ':completion:*' add-space true
#zstyle ':completion:*' completer _list _oldlist _expand _complete _ignored _match _correct _approximate _prefix
# Complete first as much as you can. Then show alternatives.
zstyle ':completion:*' completer _complete _list _oldlist _expand _ignored _match _correct _approximate _prefix
zstyle ':completion:*' completions 1
zstyle ':completion:*' file-sort name
zstyle ':completion:*' format 'Completing %d'
zstyle ':completion:*' glob 1
zstyle ':completion:*' group-name ''
zstyle ':completion:*' ignore-parents pwd
zstyle ':completion:*' list-colors ${(s.:.)LS_COLORS}
zstyle ':completion:*' list-prompt %SAt %p: Hit TAB for more, or the character to insert%s
zstyle ':completion:*' matcher-list '' 'm:{a-zA-Z}={A-Za-z}'
zstyle ':completion:*' max-errors 3 numeric
zstyle ':completion:*' menu select=long-list select=0
zstyle ':completion:*' old-menu false
zstyle ':completion:*' original true
zstyle ':completion:*' prompt '%e errors>'
zstyle ':completion:*' select-prompt %SScrolling active: current selection at %p%s
zstyle ':completion:*' special-dirs true
zstyle ':completion:*' squeeze-slashes true
zstyle ':completion:*' substitute 1
zstyle ':completion:*' use-compctl true
zstyle ':completion:*' verbose true
zstyle ':completion:*' word true

# End of lines added by compinstall

# This will cause zsh to parse the --help output and generate completions.
compdef _gnu_generic qiv

# }}}


